Unit de02e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AME2E_p, DE02ES_p, DE04EQ_p, UTDE21_p;

procedure de02e(FU :Proc_FE_DE; M :Integer; var JSTART :Integer;
                var A :Array of Extended; HMIN :Extended; EPS :Extended;
                P :Extended; var YX :Array of Extended; var X :Extended;
                var H :Extended; var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var E1 :Array of Extended;
                var E2 :Array of Extended; var E3 :Array of Extended;
                var E4 :Array of Extended; var R :Array of Extended;
                var R0 :Array of Extended; var R1 :Array of Extended;
                var R2 :Array of Extended; var R3 :Array of Extended;
                var YD :Array of Extended; var IERR :Integer);

implementation

procedure de02e(FU :Proc_FE_DE; M :Integer; var JSTART :Integer;
                var A :Array of Extended; HMIN :Extended; EPS :Extended;
                P :Extended; var YX :Array of Extended; var X :Extended;
                var H :Extended; var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var E1 :Array of Extended;
                var E2 :Array of Extended; var E3 :Array of Extended;
                var E4 :Array of Extended; var R :Array of Extended;
                var R0 :Array of Extended; var R1 :Array of Extended;
                var R2 :Array of Extended; var R3 :Array of Extended;
                var YD :Array of Extended; var IERR :Integer);
var
I,J :Integer;
C1,EPS1 :Extended;
BULD,BULEX,BULHM :Boolean;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160;
begin
IERR := 0;
EPS1 := EPS/32.e0;
BULD := True;
BULHM := False;
BULEX := False;
if ( JSTART ) < 0
 then goto _40
 else if ( JSTART ) > 0
       then goto _10
       else goto _60;
_10:
if ( JSTART =  1 ) 
 then goto _80;
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    E1[(J-1)+(I-1)*M] := E2[(J-1)+(I-1)*M];
_20:
   end;
_30:
 end;
goto _70;
_40:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_50:
 end;
X := XP;
_60:
C1 := H/4.e0;
AME2E(A,C1,M,E1,R,E3,E4);
if ( BULEX ) 
 then goto _80;
_70:
DE04EQ(M,E1,E2);
_80:
C1 := H/2.e0;
DE02ES(FU,M,X,YX,H,E2,YD,R1,R2,R3);
DE02ES(FU,M,X,YX,C1,E1,R0,R1,R2,R3);
DE02ES(FU,M,X + C1,R0,C1,E1,R,R1,R2,R3);
for I:=1 to M do
 begin
  R1[I-1] := (R[I-1] - YD[I-1])/15.e0;
  C1 := Abs(R1[I-1]);
  if ( Abs(R[I-1]) >=  P ) 
   then C1 := C1/Abs(R[I-1]);
  if ( C1 >  EPS1 ) 
   then BULD := False;
  if ( C1 >=  EPS ) 
   then goto _120;
_90:
 end;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_100:
 end;
XP := X;
for I:=1 to M do
 begin
  YX[I-1] := R[I-1];
_110:
 end;
X := X + H;
if ( BULD ) 
 then H := H*2.e0;
goto _160;
_120:
if ( BULHM ) 
 then goto _150;
H := H/2.e0;
BUL := False;
BULEX := True;
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    E2[(J-1)+(I-1)*M] := E1[(J-1)+(I-1)*M];
_130:
   end;
_140:
 end;
if ( Abs(H) >  Abs(HMIN) ) 
 then goto _60;
H := Sign(HMIN,H);
BULHM := True;
BULEX := False;
goto _60;
_150:
IERR := 65;
UTDE21(IERR,2);
_160:
JSTART := 1;
if ( BULD ) 
 then JSTART := 2;
end;

end.
